#ifndef __A4C_DICT_H
#define __A4C_DICT_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
  char * english;
  int size;
  char ** chinese;
} English2Chinese;

typedef struct {
  int size;
  English2Chinese ** DICT;
} E2C_Dictionary;

void dict_AddChinese(English2Chinese * E2C, char * chinese);
void dict_AddChineseFast(English2Chinese * E2C, char * chinese);
int dict_BinarySearchEnglish(E2C_Dictionary * DICT,char * english,int left,int right);
int dict_SearchEnglish(E2C_Dictionary * DICT,char * english);
int dict_FindEnglishGap(E2C_Dictionary * DICT,char * english,int left,int right);
int dict_InsertEnglish(E2C_Dictionary * DICT,char * english);
char * dict_FindEnglish(char * word,char **next);
char * dict_FindChinese(char * word,char **next);
int dict_LoadDictionary(FILE *fp,E2C_Dictionary * DICT);
int dict_MakeReference(char * paragraph,E2C_Dictionary * DICT,E2C_Dictionary * REF);

#endif
