#include "iome.h"
#include "a4c.tk.h"

int imeRegister(iomeSysInfo *INFO,iomeRegistry *REG)
{
  char *Accept_System[]={
    "x",
    "tty",
    NULL
  };
  char **IME = Accept_System;
  int n = 0;

  while (n>=0&&IME[n]) {
    if (strcasecmp(INFO->system,IME[n])==0) n=-2;
    n++;
  }
  if (n>=0) return 0;
  REG->encoding      = "big5";
  REG->class         = "filter";
  REG->accept_system = Accept_System;
  return 1;
}

typedef struct {
  int size;
  char **KEY;
  int from;
  int to;
  int now;
  int id;
  int indices;
  int SHAPE[1024];
} Associative;

int LoadRelativeTable(char *filename,Associative *NASA)
{
  FILE * fp;
  char buf[1024];
  fp = fopen(filename,"rt");
  if (fp==NULL) return NASA->size;
  while (fscanf(fp,"%s",buf)==1) {
    NASA->KEY = (char**)realloc(NASA->KEY,sizeof(char*)*(NASA->size+1));
    NASA->KEY[NASA->size] = strdup(buf);
    NASA->size++;
  }
  fclose(fp);
  return NASA->size;
}

int LoadAssociativeTable(char *filename,Associative *NASA)
{
  FILE * fp;
  char buf[1024];
  fp = fopen(filename,"rt");
  if (fp==NULL) return NASA->size;
  while (fscanf(fp,"%s",buf)==1) {
    
  }
  fclose(fp);
  return NASA->size;
}

int SearchKey(Associative *NASA,char *key)
{
  int n;
  int len=strlen(key);
  
  for (n=0;n<NASA->size;n++) {
    if (strncmp(NASA->KEY[n],key,len)==0) return n;
  }
  
  return -1;
}

int imeInit(iomeConfig *CONF,iomeRecord *RECORD)
{
  Associative *NASA;
  char * pages;
  iomeConfig CFG;
  int n;
  int first;

  RECORD->MethodName = NULL;
  RECORD->FilterName = iomeWhichItem(CONF,"filter.associate");
  RECORD->Encoding   = "big5";
  RECORD->ListArea   = (char*)malloc(256); RECORD->ListArea[0]=0;
  RECORD->KeyArea    = (char*)malloc(256); RECORD->KeyArea[0]=0; 
  RECORD->Value      = (char*)malloc(256); RECORD->Value[0]=0;
  NASA               = (Associative*)malloc(sizeof(Associative));
  RECORD->Owner      = NASA;
  memset(NASA,0,sizeof(Associative));
  
  pages = iomeWhichItem(CONF,"associate.pages");
  memset(&CFG,0,sizeof(CFG));
  iomeLoadConfiguration(pages,&CFG);
  for (n=0,first=0;n<CFG.size;n++) 
    if (strcmp(CFG.items[n].key,"load")==0) {
      if (first==0) {
        LoadRelativeTable(CFG.items[n].value,NASA);
        first=1;
      } else {
        LoadAssociativeTable(CFG.items[n].value,NASA);
      }
    }
  iomeFreeConfiguration(&CFG);
  
  return 1;
}

int MakeupListArea(iomeRecord *RECORD,Associative *NASA)
{
  int okay = 0;
  char * key = RECORD->KeyArea;
  int len  = strlen(key);
  int width = RECORD->MaxListArea - 8;
  int n;
  int x;
  
  NASA->from = NASA->now;
  NASA->to   = NASA->now;
  
  do {
    NASA->to++;
    if (NASA->to<NASA->size) {
      if (strncmp(NASA->KEY[NASA->to],key,len)!=0) okay = 1;
    } else okay = 1;
  } while (!okay);
  NASA->to--;
  
  NASA->id = 0;
  NASA->indices = 1;
  NASA->SHAPE[0]=NASA->now;
  len = 0;
  for (n=NASA->from;n<=NASA->to;n++) {
    x = strlen(NASA->KEY[n]) + 2;
    if ((len+x)<width) {
      len += x;
    } else {
      len = x;
      NASA->SHAPE[NASA->indices] = n;
      NASA->indices++;
    }
  }
}

int DrawIndex(iomeRecord *RECORD,Associative *NASA)
{
  int at_end = NASA->to;
  int at_begin = NASA->SHAPE[NASA->id];
  char buf[1024];
  char DIGIT[10]="1234567890";
  char * LIST = RECORD->ListArea;
  int n,i;
  
  if ((NASA->id+1)<NASA->indices) at_end = NASA->SHAPE[NASA->id+1] - 1;

  LIST[0]=0;
  for (n=at_begin,i=0;n<=at_end;n++,i++) {
    sprintf(buf,"%c%s ",DIGIT[i],NASA->KEY[n]);
    strcat(LIST,buf);
  }

  if (NASA->id==0) strcat(LIST," "); else strcat(LIST,"<");
  if ((NASA->id+1)==NASA->indices) strcat(LIST," "); else strcat(LIST,">");
  sprintf(buf,":%3d",NASA->to-at_begin+1);
  strcat(LIST,buf);
}

int imeSimple(iomeRecord *RECORD,char *charset,char *value)
{
  Associative * NASA = RECORD->Owner;
  int id;

  id = SearchKey(NASA,value);
  if (id>=0) {
    strcpy(RECORD->KeyArea,value);
    NASA->now = id;
    MakeupListArea(RECORD,NASA);
    DrawIndex(RECORD,NASA);
    return 2;
  }
  
  return 1;
}

int imeFeedKey(iomeRecord *RECORD,int ch,int state)
{
  Associative * NASA = RECORD->Owner;
  char KEYMAP[12]="!@#$%^&*()<>";
  int id;

  if (ch==IME_KEY_LEFT) id=10; else
  if (ch==IME_KEY_RIGHT) id=11; else {
    id = 0;
    while (id<12&&KEYMAP[id]!=ch) id++;
    if (ch<0||ch>0x1000) return IME_RT_BLOCKOUT;
    if (id>=12) return IME_RT_REJECT;
  }
  
  if (id==10) {
    /* left */
    if (NASA->id>0) NASA->id--; else NASA->id = NASA->indices-1;
    DrawIndex(RECORD,NASA);
  } else
  if (id==11) {
    /* right */
    NASA->id++;
    if (NASA->id==NASA->indices) NASA->id=0;
    DrawIndex(RECORD,NASA);
  } else {
    int at_begin = NASA->SHAPE[NASA->id];
    int at_end = NASA->to;
    int on = at_begin + id;
    
    if ((NASA->id+1)<NASA->indices) at_end = NASA->SHAPE[NASA->id+1] - 1;
    if (on<=at_end) {
      strcpy(RECORD->Value,&NASA->KEY[on][2]);
      strcpy(RECORD->ListArea,NASA->KEY[on]);
      return IME_RT_SEND;
    }
  }

  return IME_RT_BLOCKOUT;
}

int imeQuit(iomeRecord *RECORD)
{
  return 1;  
}

